package cn.estsh.i3plus.core.apiservice.controller;

import cn.estsh.i3plus.core.apiservice.schedulejob.CoreLogClearJob;
import cn.estsh.i3plus.platform.plugin.elasticsearch.ElasticSearchPack;
import cn.estsh.i3plus.platform.plugin.elasticsearch.ElasticSearchTool;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.model.license.ImppLicense;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogOperate;
import cn.estsh.i3plus.pojo.platform.repository.SysUserRepository;
import cn.estsh.impp.framework.base.controller.CoreBaseController;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.license.ImppLicenseTool;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.ResolvableType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-3-10 下午1:16
 * @Modify:
 **/
@RestController
@Api(tags = "测试Demo ")
@RequestMapping("/impp/demo")
public class DemoController extends CoreBaseController {

    @Autowired
    private CoreLogClearJob coreLogClearJob;

    @Autowired
    private SysUserRepository repository;


    @GetMapping(value = "/query")
    @ApiOperation(value = "添加操作日志", notes = "添加操作日志，可用于国际化")
    public ResultBean insertLogOperate() {
        try {
//            org.elasticsearch.common.xcontent.DeprecationHandler handler;
            ElasticSearchTool.init("http://192.168.3.40:9200");
            ElasticSearchPack pack = ElasticSearchPack.imppBuild(SysLogOperate.class);
            List<SysLogOperate> list = ElasticSearchTool.searchList(pack, SysLogOperate.class);
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(list);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep).build();
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


    @GetMapping(value = "/license")
    @ApiOperation(value = "添加操作日志", notes = "添加操作日志，可用于国际化")
    public ResultBean license() {
        try{
            ImppLicense license = ImppLicenseTool.getLicense();

//            SenseLockUtil lockUtil = SenseLockUtil.getSenseLockUtil(10086);
////            lockUtil.checkAPIKey();
//            String readValue = lockUtil.getReadValue();
//            System.out.println(readValue);
//            ImppLicense readLicense = (ImppLicense) SerializeTool.deserializationByte(Base64.getDecoder().decode(readValue));
//            System.out.println(JSON.toJSONString(readLicense));
//
//            String writeValue = lockUtil.getWriteValue();
//            System.out.println(writeValue);
//            ImppLicense writeLicense = (ImppLicense) SerializeTool.deserializationByte(Base64.getDecoder().decode(writeValue));
//            System.out.println(JSON.toJSONString(writeLicense));
//
//            String publicValue = lockUtil.getPublicValue();
//            System.out.println(publicValue);
//            ImppLicense publicLicense = (ImppLicense) SerializeTool.deserializationByte(Base64.getDecoder().decode(publicValue));
//            System.out.println(JSON.toJSONString(publicLicense));
//            System.out.println("Hello World ~!");

            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultObject(license);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep).build();
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }



    @GetMapping(value = "/repository")
    @ApiOperation(value = "repository 测试")
    public ResultBean repository() {
        try{
            ResolvableType resolvableType = ResolvableType.forClass(SysUserRepository.class).as(SysUserRepository.class);
            System.out.println(resolvableType.getGeneric(0));//User
            System.out.println(resolvableType.getGeneric(1));//Long

            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep).build();
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

//    @GetMapping(value = "/rabbitmq")
//    @ApiOperation(value = "repository 测试")
//    public ResultBean imppChannel() {
//        try{
//
//            String message = ImppSystemTool.getServerHost() + ":" + ImppSystemTool.getServerPort()
//                    + ":" + ImppSystemTool.getServerPid() + "Hello ->" + System.currentTimeMillis();
//            mqChannel.putMessage(message);
//            Thread.sleep(100);
//            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
//        } catch (ImppBusiException busExcep) {
//            return ResultBean.fail(busExcep).build();
//        } catch (Exception e) {
//            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
//        }
//    }

    public static void main(String[] args)throws Exception {
        ResolvableType resolvableType = ResolvableType.forClass(SysUserRepository.class).as(SysUserRepository.class);
        System.out.println(resolvableType.getGeneric(0));//User
        System.out.println(resolvableType.getGeneric(1));//Long

    }



}
